# frozen_string_literal: true

require 'httparty'

module EodFacade
  class Base
    class << self
      def make_request(url_path, params = {})
        HTTParty.get(full_url(url_path),
                     query: params.merge(
                       api_token: EodFacade::Constants.api_key
                     ),
                     format: :json)
      end

      private

      def full_url(url_path)
        "#{EodFacade::Constants.base_url}#{url_path}"
      end
    end
  end
end
