# frozen_string_literal: true

module EodServices
  class InstrumentType
    class <<self
      def etf?(symbol)
        fundamentals = EodFacade::Fundamentals.call(symbol)
        !!(fundamentals.dig('General', 'Type') == 'ETF')
      rescue ArgumentError
        false
      end

      def stock?(symbol)
        fundamentals = EodFacade::Fundamentals.call(symbol)
        !!(fundamentals.dig('General', 'Type') == 'Common Stock')
      rescue ArgumentError
        false
      end

      def option?(symbol)
        !!EodFacade::Options.call(symbol)
      rescue ArgumentError
        false
      end

      def bond?(symbol)
        !!EodFacade::BondFundamentals.call(symbol)
      rescue ArgumentError
        false
      end
    end
  end
end
