require 'ostruct'
require 'httparty'

module SenseiApi
  class Base
    class <<self
      def find_by(params)
        response = HTTParty.get(url, query: params.compact, format: :json)
        JSON.parse(response.body, object_class: OpenStruct)
      end

      def create(params)
        response = HTTParty.post(url, body: params.compact.reject { |key, _| key == :id }, format: :json)
        JSON.parse(response.body, object_class: OpenStruct)
      end

      def update(params)
        response = HTTParty.put(url, body: params.compact, format: :json)
        JSON.parse(response.body, object_class: OpenStruct)
      end

      def delete(params)
        response = HTTParty.delete(url, body: params.compact, format: :json)
        JSON.parse(response.body, object_class: OpenStruct)
      end

      def url
        raise NotImplementedError
      end
    end
  end
end